import { Common, Query, ReplicatorBase } from './couchbase-plugin.common';
export { Query, QueryMeta, QueryArrayOperator, QueryComparisonOperator, QueryLogicalOperator, QueryOrderItem, QueryWhereItem } from './couchbase-plugin.common';
export declare class Couchbase extends Common {
    ios: CBLDatabase;
    constructor(databaseName: string);
    inBatch(batch: () => void): void;
    createDocument(data: Object, documentId?: string): any;
    setBlob(id: string, name: string, blob: any, mimeType?: string): void;
    getBlob(id: string, name: string): NSData;
    private fromISO8601UTC(date);
    private serializeObject(item, object, key);
    private serializeArray(item, array);
    private serialize(item, doc, key);
    getDocument(documentId: string): any;
    numberHasDecimals(item: number): boolean;
    numberIs64Bit(item: number): boolean;
    private deserialize(data);
    updateDocument(documentId: string, data: any): void;
    deleteDocument(documentId: string): boolean;
    destroyDatabase(): boolean;
    createReplication(remoteUrl: string, direction: 'push' | 'pull' | 'both'): Replicator;
    createPushReplication(remoteUrl: string): Replicator;
    createPullReplication(remoteUrl: string): Replicator;
    addDatabaseChangeListener(callback: any): void;
    private setComparision(item);
    query(query?: Query): any[];
    private getExtension(mimeType);
}
export declare class Replicator extends ReplicatorBase {
    constructor(replicator: any);
    start(): void;
    stop(): void;
    isRunning(): boolean;
    setContinuous(isContinuous: boolean): void;
    setUserNameAndPassword(username: string, password: string): void;
    setSessionIdAndCookieName(sessionId: string, cookieName: string): void;
    setSessionId(sessionId: string): void;
}
